// AppLauncher
var AppLauncher = function() {};

/** XUL が使用する名前空間 */
AppLauncher.XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
/** AppLauncher の設定保存用 XML が使用する名前空間 */
AppLauncher.PREFS_NS = "http://www.vividcode.info/firefox_addon/myextensions/applauncher/";

/**
 * Preference 情報を取得する関数 (設定の情報)
 * @param prefString 取得するキー
 */
// cf.https://developer.mozilla.org/Ja/Code_snippets/Preferences
AppLauncher.getPref = function( prefString ) {
	var branchString = "extensions.applauncher.";
	// 設定の情報を取得する XPCOM オブジェクトの生成
	var prefSvc = Components.classes["@mozilla.org/preferences-service;1"]
							.getService(Components.interfaces.nsIPrefService);
	var prefBranch = prefSvc.getBranch(branchString);
	// タイプ別に取得する関数を分ける
	switch( prefBranch.getPrefType(prefString) ) {
		// 設定値が文字の場合
		case Components.interfaces.nsIPrefBranch.PREF_STRING:
			return prefBranch.getCharPref(prefString);
			break;
		// 設定値が数値の場合
		case Components.interfaces.nsIPrefBranch.PREF_INT:
			return prefBranch.getIntPref(prefString);
			break;
		// 設定値が真偽値の場合
		case Components.interfaces.nsIPrefBranch.PREF_BOOL:
			return prefBranch.getBoolPref(prefString);
			break;
	}
};

/**
 * Preference 情報を取得する関数 (設定の情報)
 * @param prefString 取得するキー
 */
// cf.https://developer.mozilla.org/Ja/Code_snippets/Preferences
AppLauncher.setCharPref = function( prefName, prefValue ) {
	var branchString = "extensions.applauncher.";
	// 設定の情報を取得する XPCOM オブジェクトの生成
	var prefSvc = Components.classes["@mozilla.org/preferences-service;1"]
							.getService(Components.interfaces.nsIPrefService);
	var prefBranch = prefSvc.getBranch(branchString);
	prefBranch.setCharPref(prefName, prefValue);
};
