// 名前空間
if( ! window.info ) { window.info = {}; }
if( ! info.vividcode ) { info.vividcode = {}; }
if( ! info.vividcode.ext ) { info.vividcode.ext = {}; }
if( ! info.vividcode.ext.applauncher ) { info.vividcode.ext.applauncher = {}; }

info.vividcode.ext.applauncher.AppPref = function( aName, aPath, aArgs ) {
	
	/** application の名前 */
	var mName = aName;
	/** application の path */
	var mPath = aPath;
	/** application に渡す引数 */
	if( aArgs instanceof Array ) {
		var mArgs = aArgs;
	} else {
		var mArgs = new Array(0);
	}
	
	this.getName = function() {
		return mName;
	};
	this.getPath = function() {
		return mPath;
	};
	this.getArgs = function() {
		return mArgs;
	};
	
	this.setName = function( aName ) {
		mName = aName;
	};
	this.setPath = function( aPath ) {
		mPath = aPath;
	};
	this.setArgs = function( aArgs ) {
		mArgs = aArgs;
	};
	
};

(function() {
	
	/** 設定を表示している listbox 要素の id */
	var PREFS_BOX_ID = "info.vividcode.ext.applauncher.prefwindow.listbox";
	/** XUL が使用する名前空間 */
	var XUL_NS   = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
	/** AppLauncher の設定保存用 XML が使用する名前空間 */
	var PREFS_NS = "http://www.vividcode.info/firefox_addon/myextensions/applauncher/";
	
	info.vividcode.ext.applauncher.AppPref.loadAppPrefs = function() {
		// 以前の設定を DOM として取得
		var parser  = new DOMParser();
		var prefStr = getPref("appList");
		// 初めて起動する場合, prefStr は undefined になっている
		if( ! prefStr ) {
			prefStr = "<appList ver=\"2\" xmlns=\"http://www.vividcode.info/firefox_addon/myextensions/applauncher/\" />";
		}
		var appList = parser.parseFromString( prefStr, "text/xml" );
		var version = appList.documentElement.getAttribute("ver");
		if( version == null ) {
			return loadAppPrefsV1(appList);
		} else if( version == "2" ) {
			return loadAppPrefsV2(appList);
		}
	};
	/**
	 * 設定保存, 読出しで日本語が化けないかどうかのテスト
	 *
	var test = function() {
		// 設定の情報を取得する XPCOM オブジェクトの生成
		var prefSvc = Components.classes["@mozilla.org/preferences-service;1"]
								.getService(Components.interfaces.nsIPrefService);
		var prefBranch = prefSvc.getBranch("extensions.applauncher.");
		// 保存
		prefBranch.setCharPref( "test", unescape(encodeURIComponent("日本語テスト！")) );
		// 読み出して、アラートで表示
		// 実際はタイプ別に取得する関数を分けた方がいい (と思う) が, ここでは省略
		window.alert( decodeURIComponent(escape( prefBranch.getCharPref("test") )) );
	};*/
	
	var loadAppPrefsV1 = function( aElem ) {
		var items = aElem.getElementsByTagNameNS(PREFS_NS, "app");
		// 設定画面に要素を追加していく
		var appPrefs = new Array();
		for( var i = 0; i < items.length; i++ ) {
			var item = document.createElementNS(XUL_NS, "listitem");
			item.appendChild( document.createElementNS(XUL_NS, "listcell") ).
										setAttribute( "label", items[i].getAttribute("name") );
			item.appendChild( document.createElementNS(XUL_NS, "listcell") ).
										setAttribute( "label", items[i].getAttribute("path") );
			item.appendChild( document.createElementNS(XUL_NS, "listcell") ).
										setAttribute( "label", items[i].getAttribute("args") );
			item._appPref = new info.vividcode.ext.applauncher.AppPref(
				items[i].getAttribute("name"),
				items[i].getAttribute("path"),
				items[i].getAttribute("args").split("<>")
			);
			appPrefs.push( item );
		}
		return appPrefs;
	};
	var loadAppPrefsV2 = function( aElem ) {
		var items = aElem.getElementsByTagNameNS(PREFS_NS, "app");
		// 設定画面に要素を追加していく
		var appPrefs = new Array();
		for( var i = 0; i < items.length; i++ ) {
			var args = new Array();
			var elems = items[i].getElementsByTagName("arg");
			for( var j = 0; j < elems.length; j++ ) {
				args.push( elems[j].textContent );
			}
			// 要素生成
			var item = document.createElementNS(XUL_NS, "listitem");
			item.appendChild( document.createElementNS(XUL_NS, "listcell") ).
										setAttribute( "label", items[i].getElementsByTagName("name").item(0).textContent );
			item.appendChild( document.createElementNS(XUL_NS, "listcell") ).
										setAttribute( "label", items[i].getElementsByTagName("path").item(0).textContent );
			item.appendChild( document.createElementNS(XUL_NS, "listcell") ).
										setAttribute( "label", args.toString() );
			// AppPref オブジェクト生成
			item._appPref = new info.vividcode.ext.applauncher.AppPref(
				items[i].getElementsByTagName("name").item(0).textContent,
				items[i].getElementsByTagName("path").item(0).textContent,
				args
			);
			appPrefs.push( item );
		}
		return appPrefs;
	};
	info.vividcode.ext.applauncher.AppPref.saveAppPrefs = function( aAppPrefs ) {
		// 保存用の XML Document を新たに生成
		var prefNode  = document.implementation.createDocument(PREFS_NS, "appList", null);
		prefNode.documentElement.setAttribute("ver", "2");
		// 保存用 XML に値を追加していく
		for( var i = 0; i < aAppPrefs.length; i++ ) {
			var app = document.createElementNS(PREFS_NS, "app");
			app.appendChild( document.createElementNS(PREFS_NS, "name") ).textContent = aAppPrefs[i]._appPref.getName();
			app.appendChild( document.createElementNS(PREFS_NS, "path") ).textContent = aAppPrefs[i]._appPref.getPath();
			var args = app.appendChild( document.createElementNS(PREFS_NS, "args") );
			for( var j = 0; j < aAppPrefs[i]._appPref.getArgs().length; j++ ) {
				args.appendChild( document.createElementNS(PREFS_NS, "arg") ).textContent = aAppPrefs[i]._appPref.getArgs()[j];
			}
			prefNode.documentElement.appendChild(app);
		}
		// DOM を XML 文にして保存
		// cf. https://developer.mozilla.org/ja/XMLSerializer
		var serializer = new XMLSerializer();
		var prefStr = serializer.serializeToString(prefNode);
		/*
		var stream = {
			close : function() {},
			flush : function() {},
			//write : function(string, count) { alert("'" + string + "'\n bytes count: " + count + ""); }
			write : function(string, count) { setCharPref("appList", "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + string); }
		};
		serializer.serializeToStream(prefNode, stream, "UTF-8");
		*/
		setCharPref("appList", prefStr);
		//window.alert("accept!:\n" + prefStr);
		window.alert("設定を保存しました. 設定内容を反映するためには Firefox を再起動してください.")
	};
	
	/**
	 * Preference 情報を取得する関数 (設定の情報)
	 * @param prefString 取得するキー
	 */
	// cf.https://developer.mozilla.org/Ja/Code_snippets/Preferences
	var getPref = function( prefString ) {
		var branchString = "extensions.applauncher.";
		// 設定の情報を取得する XPCOM オブジェクトの生成
		var prefSvc = Components.classes["@mozilla.org/preferences-service;1"]
								.getService(Components.interfaces.nsIPrefService);
		var prefBranch = prefSvc.getBranch(branchString);
		// タイプ別に取得する関数を分ける
		switch( prefBranch.getPrefType(prefString) ) {
			// 設定値が文字の場合
			case Components.interfaces.nsIPrefBranch.PREF_STRING:
				return decodeURIComponent(escape( prefBranch.getCharPref(prefString) ));
				break;
			// 設定値が数値の場合
			case Components.interfaces.nsIPrefBranch.PREF_INT:
				return prefBranch.getIntPref(prefString);
				break;
			// 設定値が真偽値の場合
			case Components.interfaces.nsIPrefBranch.PREF_BOOL:
				return prefBranch.getBoolPref(prefString);
				break;
		}
	};
	
	/**
	 * Preference 情報を取得する関数 (設定の情報)
	 * @param prefString 取得するキー
	 */
	// cf.https://developer.mozilla.org/Ja/Code_snippets/Preferences
	var setCharPref = function( prefName, prefValue ) {
		var branchString = "extensions.applauncher.";
		// 設定の情報を取得する XPCOM オブジェクトの生成
		var prefSvc = Components.classes["@mozilla.org/preferences-service;1"]
								.getService(Components.interfaces.nsIPrefService);
		var prefBranch = prefSvc.getBranch(branchString);
		prefBranch.setCharPref( prefName, unescape(encodeURIComponent(prefValue)) );
	};
	
})();
