// 名前空間
if( ! window.info ) { window.info = {}; }
if( ! info.vividcode ) { info.vividcode = {}; }
if( ! info.vividcode.ext ) { info.vividcode.ext = {}; }
if( ! info.vividcode.ext.applauncher ) { info.vividcode.ext.applauncher = {}; }

info.vividcode.ext.applauncher.PrefsManager = function() {
	
	/** 設定を表示している listbox 要素の id */
	var PREFS_BOX_ID = "info.vividcode.ext.applauncher.prefwindow.listbox";
	/** XUL が使用する名前空間 */
	var XUL_NS   = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
	/** AppLauncher の設定保存用 XML が使用する名前空間 */
	var PREFS_NS = "http://www.vividcode.info/firefox_addon/myextensions/applauncher/";
	
	var AppPref = info.vividcode.ext.applauncher.AppPref;
	
	/**
	 * 設定を取得し, 保存する
	 */
	this.savePrefs = function() {
		try {
			AppPref.saveAppPrefs( document.getElementById(PREFS_BOX_ID).getElementsByTagName("listitem") );
		} catch(e) {
			window.alert(e);
		}
	};
	
	/**
	 * ユーザの設定画面に以前の設定を読み出す.
	 */
	this.loadPrefs = function() {
		try {
			var appPrefs = AppPref.loadAppPrefs();
			// 設定画面の要素を取得
			var listbox = document.getElementById(PREFS_BOX_ID);
			// 設定画面に要素を追加していく
			for( var i = 0; i < appPrefs.length; i++ ) {
				listbox.appendChild( appPrefs[i] );
			}
		} catch(e) {
			window.alert(e);
		}
	};
	
	this.editAppPref = function() {
		try {
			var item = getSelectedItem();
			var params = {inn: item._appPref, out: null};
			window.openDialog("chrome://applauncher/content/prefs_dialog.xul", "", "chrome,dialog,modal,resizable=yes", params).focus();
			items = item.getElementsByTagName("listcell");
			items[0].setAttribute( "label", item._appPref.getName() );
			items[1].setAttribute( "label", item._appPref.getPath() );
			items[2].setAttribute( "label", item._appPref.getArgs().toString() );
		} catch(e) {
			window.alert(e);
		}
	};
	this.deleteAppPref = function() {
		try {
			var item = getSelectedItem();
			var params = {title: "設定を削除してよろしいですか？", message: "選択されているアプリケーションの設定を削除してよろしいですか？", returnValue: null};
			window.openDialog("chrome://applauncher/content/confDialog.xul", "", "chrome,dialog,modal,resizable=yes", params).focus();
			if( params.returnValue ) {
				item.parentNode.removeChild( item );
			}
		} catch(e) {
			window.alert(e);
		}
	};
	this.moveUpAppPref = function() {
		try {
			var item = getSelectedItem();
			if( item.previousSibling != null && item.previousSibling.nodeName == "listitem" ) {
				item.parentNode.insertBefore(item, item.previousSibling);
				item.parentNode.selectedItem = item;
			}
		} catch(e) {
			window.alert(e);
		}
	};
	this.moveDownAppPref = function() {
		try {
			var item = getSelectedItem();
			if( item.nextSibling != null && item.nextSibling.nodeName == "listitem" ) {
				item.parentNode.insertBefore(item.nextSibling, item);
			}
		} catch(e) {
			window.alert(e);
		}
	};
	this.addAppPref = function() {
		try {
			var params = {inn: new AppPref("", "", null), out: null};
			window.openDialog("chrome://applauncher/content/prefs_dialog.xul", "", "chrome,dialog,modal,resizable=yes", params).focus();
			if( params.out ) {
				var item = document.createElementNS(XUL_NS, "listitem");
				item._appPref = params.inn;
				item.getElementsByTagName("listcell");
				item.appendChild( document.createElementNS(XUL_NS, "listcell") ).
													setAttribute( "label", item._appPref.getName() );
				item.appendChild( document.createElementNS(XUL_NS, "listcell") ).
													setAttribute( "label", item._appPref.getPath() );
				item.appendChild( document.createElementNS(XUL_NS, "listcell") ).
													setAttribute( "label", item._appPref.getArgs().toString() );
				// 追加
				document.getElementById(PREFS_BOX_ID).appendChild( item );
			}
		} catch(e) {
			window.alert(e);
		}
	};
	
	this.nonsaveAndExit = function(evt) {
		try {
			var params = {title: "設定を保存せずに終了しますか？", message: "設定の変更を保存せずに終了しますが, よろしいですか？", returnValue: null};
			window.openDialog("chrome://applauncher/content/confDialog.xul", "", "chrome,dialog,modal,resizable=yes", params).focus();
			if( ! params.returnValue ) {
				evt.preventDefault();
			}
		} catch(e) {
			window.alert(e);
		}
	};
	
	/**
	 * 初期化を行う
	 */
	this.init = function() {
		try {
			this.loadPrefs();
			// Event Listener の追加
			var obj = this;
			document.getElementById("info.vividcode.ext.applauncher.prefwindow.button.edit").
				addEventListener("command", function(evt) { obj.editAppPref(); }, false);
			document.getElementById("info.vividcode.ext.applauncher.prefwindow.button.delete").
				addEventListener("command", function(evt) { obj.deleteAppPref(); }, false);
			document.getElementById("info.vividcode.ext.applauncher.prefwindow.button.moveup").
				addEventListener("command", function(evt) { obj.moveUpAppPref(); }, false);
			document.getElementById("info.vividcode.ext.applauncher.prefwindow.button.movedown").
				addEventListener("command", function(evt) { obj.moveDownAppPref(); }, false);
			document.getElementById("info.vividcode.ext.applauncher.prefwindow.button.add").
				addEventListener("command", function(evt) { obj.addAppPref(); }, false);
			window.addEventListener( "dialogaccept", function(evt) { obj.savePrefs() }, false );
			window.addEventListener( "dialogcancel", function(evt) { obj.nonsaveAndExit(evt) }, false );
		} catch(e) {
			window.alert(e);
		}
	};
	
	/**
	 * Preference 情報を取得する関数 (設定の情報)
	 * @param prefString 取得するキー
	 */
	// cf.https://developer.mozilla.org/Ja/Code_snippets/Preferences
	var getPref = function( prefString ) {
		var branchString = "extensions.applauncher.";
		// 設定の情報を取得する XPCOM オブジェクトの生成
		var prefSvc = Components.classes["@mozilla.org/preferences-service;1"]
								.getService(Components.interfaces.nsIPrefService);
		var prefBranch = prefSvc.getBranch(branchString);
		// タイプ別に取得する関数を分ける
		switch( prefBranch.getPrefType(prefString) ) {
			// 設定値が文字の場合
			case Components.interfaces.nsIPrefBranch.PREF_STRING:
				return prefBranch.getCharPref(prefString);
				break;
			// 設定値が数値の場合
			case Components.interfaces.nsIPrefBranch.PREF_INT:
				return prefBranch.getIntPref(prefString);
				break;
			// 設定値が真偽値の場合
			case Components.interfaces.nsIPrefBranch.PREF_BOOL:
				return prefBranch.getBoolPref(prefString);
				break;
		}
	};
	
	/**
	 * Preference 情報を取得する関数 (設定の情報)
	 * @param prefString 取得するキー
	 */
	// cf.https://developer.mozilla.org/Ja/Code_snippets/Preferences
	var setCharPref = function( prefName, prefValue ) {
		var branchString = "extensions.applauncher.";
		// 設定の情報を取得する XPCOM オブジェクトの生成
		var prefSvc = Components.classes["@mozilla.org/preferences-service;1"]
								.getService(Components.interfaces.nsIPrefService);
		var prefBranch = prefSvc.getBranch(branchString);
		prefBranch.setCharPref(prefName, prefValue);
	};
	
	/**
	 * 選択されている項目を取得する
	 */
	var getSelectedItem = function() {
		var listbox = document.getElementById(PREFS_BOX_ID);
		var items = listbox.selectedItems;
		// 選択項目が無い
		if( items.length == 0 ) {
			//throw new Error("選択されている項目がありません. 項目を選択してください.");
			throw new Error("There is no selected item. Please select an item.");
		}
		// 2 つ以上選択されている
		else if( items.length > 1 ) {
			//throw new Error("2 つ以上のアイテムが選択されています. 1 つだけ選択するようにしてください.");
			throw new Error("There are two or more selected item. Please select only one item.");
		}
		return items[0];
	};
	
};


/*
AppLauncher.addNewApprication = function() {
	var listitem = document.createElementNS(AppLauncher.XUL_NS, "listitem");
	var listcell = document.createElementNS(AppLauncher.XUL_NS, "listcell");
	listcell.setAttribute("label", document.getElementById("info.vividcode.applauncher.prefwindow.adding.name").value);
	listitem.appendChild(listcell);
	var listcell = document.createElementNS(AppLauncher.XUL_NS, "listcell");
	listcell.setAttribute("label", document.getElementById("info.vividcode.applauncher.prefwindow.adding.path").value);
	listitem.appendChild(listcell);
	var listcell = document.createElementNS(AppLauncher.XUL_NS, "listcell");
	listcell.setAttribute("label", document.getElementById("info.vividcode.applauncher.prefwindow.adding.args").value);
	listitem.appendChild(listcell);
	listitem.addEventListener("dblclick", this.elDeletingApp, false);
	document.getElementById("info.vividcode.applauncher.prefwindow.listbox").appendChild(listitem);
};

AppLauncher.deleteSelectedApprication = function() {
	var listbox = document.getElementById("info.vividcode.applauncher.prefwindow.listbox");
	var items = listbox.selectedItems;
	// 選択項目が無い
	if( items.length == 0 ) {
		throw new Error("選択されている項目がありません.");
	}
	// 2 つ以上選択されている
	else if( items.length > 1 ) {
		throw new Error("2 つ以上のアイテムが選択されています.");
	}
	listbox.removeChild( items[0] );
	/*
	var listitem = document.createElementNS(AppLauncher.XUL_NS, "listitem");
	var listcell = document.createElementNS(AppLauncher.XUL_NS, "listcell");
	listcell.setAttribute("label", document.getElementById("info.vividcode.applauncher.prefwindow.adding.name").value);
	listitem.appendChild(listcell);
	var listcell = document.createElementNS(AppLauncher.XUL_NS, "listcell");
	listcell.setAttribute("label", document.getElementById("info.vividcode.applauncher.prefwindow.adding.path").value);
	listitem.appendChild(listcell);
	var listcell = document.createElementNS(AppLauncher.XUL_NS, "listcell");
	listcell.setAttribute("label", document.getElementById("info.vividcode.applauncher.prefwindow.adding.args").value);
	listitem.appendChild(listcell);
	document.getElementById("info.vividcode.applauncher.prefwindow.listbox").appendChild(listitem);
	*
};

/**
 * アプリケーションの実行ファイルを選択するための関数.
 * ver.0.5 で追加.
 * cf. https://developer.mozilla.org/ja/XUL_Tutorial/Open_and_Save_Dialogs
 * cf. http://piro.sakura.ne.jp/xul/tips/x0022.html
 *
AppLauncher.selectApplicationFile = function() {
	// ファイルピッカーの生成
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, "Select a application file", nsIFilePicker.modeOpen); // 第 1 引数は開きもとの window
	// フィルターの追加 (実行ファイルのみを表示する)
	fp.appendFilters(nsIFilePicker.filterApps);
	// ダイアログの表示
	var returnCode = fp.show();
	// OK であれば...
	if( returnCode == nsIFilePicker.returnOK ) {
		window.alert( fp.file.path + " が選択されました." );
	} else {
		window.alert("ファイル選択: OK 以外です...");
	}
}

AppLauncher.elAddingApp = function(evt) {
	AppLauncher.addNewApprication();
};

AppLauncher.elDeletingApp = function(evt) {
	AppLauncher.deleteSelectedApprication();
};

AppLauncher.elSelectingApp = function(evt) {
	AppLauncher.selectApplicationFile();
};

/**
 * OK ボタンの実行をキャッチするイベントリスナ.
 *
AppLauncher.accept = function(evt) {
	AppLauncher.savePrefs();
};

AppLauncher.cancel = function(evt) {
	window.alert("cancel...");
};

AppLauncher.initPref = function(evt) {
	// "OK" ボタンおよび "キャンセル" ボタンにイベントリスナの追加
	var item = document.getElementById("info.vividcode.applauncher.prefwindow");
	if( item ) {
		item.addEventListener("dialogaccept", AppLauncher.accept, false);
		item.addEventListener("dialogcancel", AppLauncher.cancel, false);
	}
	// "add" ボタンにイベントリスナを追加
	item = document.getElementById("info.vividcode.applauncher.prefwindow.adding.button");
	if( item ) {
		item.addEventListener("command", AppLauncher.elAddingApp, false);
	}
	// "select" ボタンにイベントリスナを追加
	item = document.getElementById("info.vividcode.applauncher.prefwindow.adding.selectButton");
	if( item ) {
		item.addEventListener("command", AppLauncher.elSelectingApp, false);
	}
	// 設定の読み込み
	AppLauncher.loadPrefs();
};
*/
