// AppLauncher の設定に関する JavaScript
if( ! window.info ) { window.info = {}; }
if( ! info.vividcode ) { info.vividcode = {}; }
if( ! info.vividcode.ext ) { info.vividcode.ext = {}; }
if( ! info.vividcode.ext.applauncher ) { info.vividcode.ext.applauncher = {}; }

info.vividcode.ext.applauncher.PrefsManager = function() {
};

/**
 * ユーザが設定画面に入力した値を XML 形式で保存する.
 */
AppLauncher.savePrefs = function() {
	// 設定画面の要素を取得
	var listbox = document.getElementById("info.vividcode.applauncher.prefwindow.listbox");
	var items   = listbox.getElementsByTagNameNS(this.XUL_NS, "listitem");
	// 保存用の XML Document を新たに生成
	var prefNode  = document.implementation.createDocument(this.PREFS_NS, "appList", null);
	// 保存用 XML に値を追加していく
	for( var i = 0; i < items.length; i++ ) {
		var cells = items[i].getElementsByTagNameNS(this.XUL_NS, "listcell");
		var app = document.createElementNS(this.PREFS_NS, "app");
		app.setAttribute( "name", cells[0].getAttribute("label") );
		app.setAttribute( "path", cells[1].getAttribute("label") );
		app.setAttribute( "args", cells[2].getAttribute("label") );
		prefNode.documentElement.appendChild(app);
	}
	// DOM を XML 文にして保存
	// cf. https://developer.mozilla.org/ja/XMLSerializer
	var serializer = new XMLSerializer();
	var prefStr = serializer.serializeToString(prefNode);
	this.setCharPref("appList", prefStr);
	window.alert("accept!:\n" + prefStr);
};

/**
 * ユーザの設定画面に以前の設定を読み出す.
 */
AppLauncher.loadPrefs = function() {
	// 以前の設定を DOM として取得
	var appListStr = this.getPref("appList");
	var parser  = new DOMParser();
	var appList = parser.parseFromString(appListStr, "text/xml");
	var items   = appList.getElementsByTagNameNS(this.PREFS_NS, "app");
	// 設定画面の要素を取得
	var listbox = document.getElementById("info.vividcode.applauncher.prefwindow.listbox");
	//var items   = listbox.getElementsByTagNameNS(this.XUL_NS, "listitem");
	// 設定画面に要素を追加していく
	for( var i = 0; i < items.length; i++ ) {
		var item = document.createElementNS(this.XUL_NS, "listitem");
		var cell = document.createElementNS(this.XUL_NS, "listcell");
		cell.setAttribute( "label", items[i].getAttribute("name") );
		item.appendChild(cell);
		cell = document.createElementNS(this.XUL_NS, "listcell");
		cell.setAttribute( "label", items[i].getAttribute("path") );
		item.appendChild(cell);
		cell = document.createElementNS(this.XUL_NS, "listcell");
		cell.setAttribute( "label", items[i].getAttribute("args") );
		item.appendChild(cell);
		item.addEventListener("dblclick", this.elDeletingApp, false);
		listbox.appendChild(item);
	}
};

AppLauncher.addNewApprication = function() {
	var listitem = document.createElementNS(AppLauncher.XUL_NS, "listitem");
	var listcell = document.createElementNS(AppLauncher.XUL_NS, "listcell");
	listcell.setAttribute("label", document.getElementById("info.vividcode.applauncher.prefwindow.adding.name").value);
	listitem.appendChild(listcell);
	var listcell = document.createElementNS(AppLauncher.XUL_NS, "listcell");
	listcell.setAttribute("label", document.getElementById("info.vividcode.applauncher.prefwindow.adding.path").value);
	listitem.appendChild(listcell);
	var listcell = document.createElementNS(AppLauncher.XUL_NS, "listcell");
	listcell.setAttribute("label", document.getElementById("info.vividcode.applauncher.prefwindow.adding.args").value);
	listitem.appendChild(listcell);
	listitem.addEventListener("dblclick", this.elDeletingApp, false);
	document.getElementById("info.vividcode.applauncher.prefwindow.listbox").appendChild(listitem);
};

AppLauncher.deleteSelectedApprication = function() {
	var listbox = document.getElementById("info.vividcode.applauncher.prefwindow.listbox");
	var items = listbox.selectedItems;
	// 選択項目が無い
	if( items.length == 0 ) {
		throw new Error("選択されている項目がありません.");
	}
	// 2 つ以上選択されている
	else if( items.length > 1 ) {
		throw new Error("2 つ以上のアイテムが選択されています.");
	}
	listbox.removeChild( items[0] );
	/*
	var listitem = document.createElementNS(AppLauncher.XUL_NS, "listitem");
	var listcell = document.createElementNS(AppLauncher.XUL_NS, "listcell");
	listcell.setAttribute("label", document.getElementById("info.vividcode.applauncher.prefwindow.adding.name").value);
	listitem.appendChild(listcell);
	var listcell = document.createElementNS(AppLauncher.XUL_NS, "listcell");
	listcell.setAttribute("label", document.getElementById("info.vividcode.applauncher.prefwindow.adding.path").value);
	listitem.appendChild(listcell);
	var listcell = document.createElementNS(AppLauncher.XUL_NS, "listcell");
	listcell.setAttribute("label", document.getElementById("info.vividcode.applauncher.prefwindow.adding.args").value);
	listitem.appendChild(listcell);
	document.getElementById("info.vividcode.applauncher.prefwindow.listbox").appendChild(listitem);
	*/
};

/**
 * アプリケーションの実行ファイルを選択するための関数.
 * ver.0.5 で追加.
 * cf. https://developer.mozilla.org/ja/XUL_Tutorial/Open_and_Save_Dialogs
 * cf. http://piro.sakura.ne.jp/xul/tips/x0022.html
 */
AppLauncher.selectApplicationFile = function() {
	// ファイルピッカーの生成
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, "Select a application file", nsIFilePicker.modeOpen); // 第 1 引数は開きもとの window
	// フィルターの追加 (実行ファイルのみを表示する)
	fp.appendFilters(nsIFilePicker.filterApps);
	// ダイアログの表示
	var returnCode = fp.show();
	// OK であれば...
	if( returnCode == nsIFilePicker.returnOK ) {
		window.alert( fp.file.path + " が選択されました." );
	} else {
		window.alert("ファイル選択: OK 以外です...");
	}
}

AppLauncher.elAddingApp = function(evt) {
	AppLauncher.addNewApprication();
};

AppLauncher.elDeletingApp = function(evt) {
	AppLauncher.deleteSelectedApprication();
};

AppLauncher.elSelectingApp = function(evt) {
	AppLauncher.selectApplicationFile();
};

/**
 * OK ボタンの実行をキャッチするイベントリスナ.
 */
AppLauncher.accept = function(evt) {
	AppLauncher.savePrefs();
};

AppLauncher.cancel = function(evt) {
	window.alert("cancel...");
};

AppLauncher.initPref = function(evt) {
	// "OK" ボタンおよび "キャンセル" ボタンにイベントリスナの追加
	var item = document.getElementById("info.vividcode.applauncher.prefwindow");
	if( item ) {
		item.addEventListener("dialogaccept", AppLauncher.accept, false);
		item.addEventListener("dialogcancel", AppLauncher.cancel, false);
	}
	// "add" ボタンにイベントリスナを追加
	item = document.getElementById("info.vividcode.applauncher.prefwindow.adding.button");
	if( item ) {
		item.addEventListener("command", AppLauncher.elAddingApp, false);
	}
	// "select" ボタンにイベントリスナを追加
	item = document.getElementById("info.vividcode.applauncher.prefwindow.adding.selectButton");
	if( item ) {
		item.addEventListener("command", AppLauncher.elSelectingApp, false);
	}
	// 設定の読み込み
	AppLauncher.loadPrefs();
};

// 初期化関数をロード時に実行する
window.addEventListener("load", AppLauncher.initPref, false);
